module crc32_async(I_FEED,I_CRC32,I_DATA,O_CRC32);

// ̓|[g
input   [31:0]  I_FEED;
input   [31:0]  I_CRC32;
input   I_DATA;

// o̓|[g
output  [31:0] O_CRC32;

// ŎgpM
wire [31:0] left_shift;
wire        left_shift_cary;

// Vtg
assign left_shift      = {I_CRC32[30:0],1'b0}; // (I_CRC32<<1)
// VtgAL[AEg
assign left_shift_cary = I_CRC32[31] ^ I_DATA; // (I_CRC32>>31) ^ I_DATA

// CRC32o
assign O_CRC32 = 
  left_shift_cary ? left_shift ^ I_FEED // L[
                  : left_shift;         // L[Ȃ

endmodule
