module crc32_if(I_CLK,I_CS,I_RD,I_WR,I_A,I_DATA,O_DATA,O_DATAEN)

// ̓|[g
input	I_CLK;
input	I_CS;
input	I_RD;
input	I_WR;
input [7:2] I_A;

input	[31:0] I_DATA;
// o̓|[g
output  [31:0] O_DATA;
output  O_DATAEN;

/*
write 
+00 SIN (8bit)
+04 CRC32
+08 control

read
+00 CRC32 data
+04 status

*/

// Lfq(RTLLq'R'j
reg	[31:0] crc32_in;

reg	[7:0]	shift_reg;
reg	[31:0] O_CRC32;
reg	DONE;

// ʃW[Ƃ̎󂯓n
wire [31:0] crc32_async;
//
crc32_async crc32_async(
	.I_FEED(I_FEED),
	.I_CRC32(I_CRC32),
	.I_DATA(shift_reg[7]),
	.O_CRC32(crc32_async)
);

// Xe[g}V
always @(posedge I_CLK)
begin
	// X^[g
	if(DONE==1'b1)
	begin
		// 	ҋ@
		bit_counter <= 3'h0;
		if(I_START)
		begin
			DONE <= 1'b0;
			shift_reg <= I_SIN8;
		end
	end else begin
		// JEgAbvƃXgbv
		bit_counter <= bit_counter;
		if(bit_counter==3'h7)
		begin
			O_CRC32 <= crc32_async;
			DONE <= 1'b0;
		end
		// f[^rbg̍Vtg
		shift_reg <= {shift_reg[6:0],1'b0};
	end
end

endmodule
