// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _Vcrc32_sync8_H_
#define _Vcrc32_sync8_H_

#include "verilated.h"
class Vcrc32_sync8__Syms;

//----------

VL_MODULE(Vcrc32_sync8) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(I_CLK,0,0);
    VL_IN8(I_RESET,0,0);
    VL_IN8(I_SIN8,7,0);
    VL_IN8(I_START,0,0);
    VL_IN8(I_LOAD,0,0);
    VL_OUT8(O_READY,0,0);
    //char	__VpadToAlign6[2];
    VL_IN(I_FEED,31,0);
    VL_IN(I_CRC32,31,0);
    VL_OUT(O_CRC32,31,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    VL_SIG8(v__DOT__bit_counter,2,0);
    VL_SIG8(v__DOT__reg_shift_data,7,0);
    VL_SIG8(v__DOT__reg_busy,0,0);
    //char	__VpadToAlign27[1];
    VL_SIG(v__DOT__reg_crc32,31,0);
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    VL_SIG8(__Vclklast__TOP__I_CLK,0,0);
    //char	__VpadToAlign37[3];
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    //char	__VpadToAlign44[4];
    Vcrc32_sync8__Syms*	__VlSymsp;		// Symbol table
    
    // PARAMETERS
    // Parameters marked /*verilator public*/ for use by application code
    
    // CONSTRUCTORS
  private:
    Vcrc32_sync8& operator= (const Vcrc32_sync8&);	///< Copying not allowed
    Vcrc32_sync8(const Vcrc32_sync8&);	///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible WRT DPI scope names.
    Vcrc32_sync8(const char* name="TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~Vcrc32_sync8();
    
    // USER METHODS
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(Vcrc32_sync8__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(Vcrc32_sync8__Syms* symsp, bool first);
  private:
    static IData	_change_request(Vcrc32_sync8__Syms* __restrict vlSymsp);
  public:
    static void	_eval(Vcrc32_sync8__Syms* __restrict vlSymsp);
    static void	_eval_initial(Vcrc32_sync8__Syms* __restrict vlSymsp);
    static void	_eval_settle(Vcrc32_sync8__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__1(Vcrc32_sync8__Syms* __restrict vlSymsp);
    static void	_settle__TOP__2(Vcrc32_sync8__Syms* __restrict vlSymsp);
} VL_ATTR_ALIGNED(64);

#endif  /*guard*/
