// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See Vcrc32_sync8.h for the primary calling header

#include "Vcrc32_sync8.h"      // For This
#include "Vcrc32_sync8__Syms.h"

//--------------------
// STATIC VARIABLES


//--------------------

VL_CTOR_IMP(Vcrc32_sync8) {
    Vcrc32_sync8__Syms* __restrict vlSymsp = __VlSymsp = new Vcrc32_sync8__Syms(this, name());
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Reset internal values
    
    // Reset structure values
    I_RESET = VL_RAND_RESET_I(1);
    I_CLK = VL_RAND_RESET_I(1);
    I_FEED = VL_RAND_RESET_I(32);
    I_CRC32 = VL_RAND_RESET_I(32);
    I_SIN8 = VL_RAND_RESET_I(8);
    I_START = VL_RAND_RESET_I(1);
    I_LOAD = VL_RAND_RESET_I(1);
    O_CRC32 = VL_RAND_RESET_I(32);
    O_READY = VL_RAND_RESET_I(1);
    v__DOT__bit_counter = VL_RAND_RESET_I(3);
    v__DOT__reg_shift_data = VL_RAND_RESET_I(8);
    v__DOT__reg_crc32 = VL_RAND_RESET_I(32);
    v__DOT__reg_busy = VL_RAND_RESET_I(1);
    __Vclklast__TOP__I_CLK = VL_RAND_RESET_I(1);
}

void Vcrc32_sync8::__Vconfigure(Vcrc32_sync8__Syms* vlSymsp, bool first) {
    if (0 && first) {}  // Prevent unused
    this->__VlSymsp = vlSymsp;
}

Vcrc32_sync8::~Vcrc32_sync8() {
    delete __VlSymsp; __VlSymsp=NULL;
}

//--------------------


void Vcrc32_sync8::eval() {
    Vcrc32_sync8__Syms* __restrict vlSymsp = this->__VlSymsp; // Setup global symbol table
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) _eval_initial_loop(vlSymsp);
    // Evaluate till stable
    VL_DEBUG_IF(VL_PRINTF("\n----TOP Evaluate Vcrc32_sync8::eval\n"); );
    int __VclockLoop = 0;
    IData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	VL_DEBUG_IF(VL_PRINTF(" Clock loop\n"););
	vlSymsp->__Vm_activity = true;
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't converge");
    }
}

void Vcrc32_sync8::_eval_initial_loop(Vcrc32_sync8__Syms* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    _eval_initial(vlSymsp);
    vlSymsp->__Vm_activity = true;
    int __VclockLoop = 0;
    IData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	_eval_settle(vlSymsp);
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't DC converge");
    }
}

//--------------------
// Internal Methods

void Vcrc32_sync8::_sequent__TOP__1(Vcrc32_sync8__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vcrc32_sync8::_sequent__TOP__1\n"); );
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Variables
    VL_SIG8(__Vdly__v__DOT__bit_counter,2,0);
    VL_SIG8(__Vdly__v__DOT__reg_shift_data,7,0);
    VL_SIG8(__Vdly__v__DOT__reg_busy,0,0);
    //char	__VpadToAlign7[1];
    VL_SIG(__Vdly__v__DOT__reg_crc32,31,0);
    // Body
    __Vdly__v__DOT__bit_counter = vlTOPp->v__DOT__bit_counter;
    __Vdly__v__DOT__reg_shift_data = vlTOPp->v__DOT__reg_shift_data;
    __Vdly__v__DOT__reg_crc32 = vlTOPp->v__DOT__reg_crc32;
    __Vdly__v__DOT__reg_busy = vlTOPp->v__DOT__reg_busy;
    // ALWAYS at ../rtl/crc32_sync8.v:35
    if (vlTOPp->I_RESET) {
	__Vdly__v__DOT__bit_counter = 0;
	__Vdly__v__DOT__reg_shift_data = 0;
	__Vdly__v__DOT__reg_crc32 = 0xffffffff;
	__Vdly__v__DOT__reg_busy = 0;
    } else {
	if (vlTOPp->v__DOT__reg_busy) {
	    __Vdly__v__DOT__reg_crc32 = ((1 & ((vlTOPp->v__DOT__reg_crc32 
						>> 0x1f) 
					       ^ ((IData)(vlTOPp->v__DOT__reg_shift_data) 
						  >> 7)))
					  ? ((0xfffffffe 
					      & (vlTOPp->v__DOT__reg_crc32 
						 << 1)) 
					     ^ vlTOPp->I_FEED)
					  : (0xfffffffe 
					     & (vlTOPp->v__DOT__reg_crc32 
						<< 1)));
	    __Vdly__v__DOT__bit_counter = (7 & ((IData)(1) 
						+ (IData)(vlTOPp->v__DOT__bit_counter)));
	    __Vdly__v__DOT__reg_shift_data = (0xfe 
					      & ((IData)(vlTOPp->v__DOT__reg_shift_data) 
						 << 1));
	    if ((7 == (IData)(vlTOPp->v__DOT__bit_counter))) {
		__Vdly__v__DOT__reg_busy = 0;
	    }
	} else {
	    if (vlTOPp->I_START) {
		__Vdly__v__DOT__reg_busy = 1;
		__Vdly__v__DOT__bit_counter = 0;
		__Vdly__v__DOT__reg_shift_data = vlTOPp->I_SIN8;
	    }
	    if (vlTOPp->I_LOAD) {
		__Vdly__v__DOT__reg_crc32 = vlTOPp->I_CRC32;
	    }
	}
    }
    vlTOPp->v__DOT__reg_shift_data = __Vdly__v__DOT__reg_shift_data;
    vlTOPp->v__DOT__bit_counter = __Vdly__v__DOT__bit_counter;
    vlTOPp->v__DOT__reg_crc32 = __Vdly__v__DOT__reg_crc32;
    vlTOPp->v__DOT__reg_busy = __Vdly__v__DOT__reg_busy;
    vlTOPp->O_CRC32 = vlTOPp->v__DOT__reg_crc32;
    vlTOPp->O_READY = (1 & (~ (IData)(vlTOPp->v__DOT__reg_busy)));
}

void Vcrc32_sync8::_settle__TOP__2(Vcrc32_sync8__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vcrc32_sync8::_settle__TOP__2\n"); );
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->O_CRC32 = vlTOPp->v__DOT__reg_crc32;
    vlTOPp->O_READY = (1 & (~ (IData)(vlTOPp->v__DOT__reg_busy)));
}

void Vcrc32_sync8::_eval(Vcrc32_sync8__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vcrc32_sync8::_eval\n"); );
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    if (((IData)(vlTOPp->I_CLK) & (~ (IData)(vlTOPp->__Vclklast__TOP__I_CLK)))) {
	vlTOPp->_sequent__TOP__1(vlSymsp);
    }
    // Final
    vlTOPp->__Vclklast__TOP__I_CLK = vlTOPp->I_CLK;
}

void Vcrc32_sync8::_eval_initial(Vcrc32_sync8__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vcrc32_sync8::_eval_initial\n"); );
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vcrc32_sync8::final() {
    VL_DEBUG_IF(VL_PRINTF("    Vcrc32_sync8::final\n"); );
    // Variables
    Vcrc32_sync8__Syms* __restrict vlSymsp = this->__VlSymsp;
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vcrc32_sync8::_eval_settle(Vcrc32_sync8__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vcrc32_sync8::_eval_settle\n"); );
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_settle__TOP__2(vlSymsp);
}

IData Vcrc32_sync8::_change_request(Vcrc32_sync8__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vcrc32_sync8::_change_request\n"); );
    Vcrc32_sync8* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    IData __req = false;  // Logically a bool
    return __req;
}
