/*
	CRC32 calcrator
*/

#include "stdio.h"

/////////////////////////////////////////////////////////////////////////////
// t@CCRCvZ
/////////////////////////////////////////////////////////////////////////////
void cpp_crc_calc(
	const char *filepath,
	int calc_size,
	unsigned int crc_initial,
	unsigned int crc_polynomial,
	unsigned int *crc
)
{
	unsigned char crc_din;
	int num_calc;
	FILE *fp,*fpcom;

	unsigned int crc32;
	int bit;

	// t@C̃I[v
	fp = fopen(filepath,"rb");
	if(fp==0)
	{
		printf("Can't open data file\n");
		return;
	}

	crc32 = crc_initial;


	// t@Cŏ̂PoCg[h
	for(num_calc=0;num_calc<calc_size;num_calc++)
	{
		if( (crc_din=fgetc(fp)) <0) break;
		// PoCgCRCvZ
		crc32 ^= crc_din<<24;
		for(bit=0;bit<8;bit++)
		{
			if(crc32&0x80000000)
				crc32 = (crc32<<1) ^ crc_polynomial;
			else
				crc32 = (crc32<<1);
		}
	}
	*crc = crc32;

	fclose(fp);
}

